// vim: set tw=80 ts=2 sw=2 sts=2:

import * as moment from 'moment';

import { Injectable } from '@angular/core';
import { Observable } from 'rxjs/Rx';

import { Restangular } from "ngx-restangular";

import { Category } from './category';

@Injectable()
export class CategoryService {
  constructor(
    private restangular: Restangular
  ) {}

  formatDate(date: Date|string) {
    if(date instanceof Date) {
      return moment(date).format('YYYY-MM-DD');
    }

    return date;
  }

  query(id: number, minDate: Date = null, maxDate: Date = null): Observable<Category[]> {
    var dateRange: any = {};

    if(minDate) {
      dateRange.begin = this.formatDate(minDate);
    }

    if(maxDate) {
      dateRange.end = this.formatDate(maxDate);
    }

    return this.restangular.one('account', id).getList('category', dateRange);
  }
}
